{****************************************************************************************************}
{Program je upraveny pre chod pod DPMI aj napriek chybe v jednotke CRT, nepouzivat Uses CRT vobec !!!}
{Program je odladeny aj pre Windows XP, kde ale mozeme alokovat len 8MB EMS pamati ...               }
{****************************************************************************************************}
program EMS;

(*{$M $0FFF1,$1000,$A0000}*)

{$N-,E-,F-,B-,G+,A+,R-,S-,I-,X-,V-,C-,O-,Y-,T-,D+,L+}

{$IFDEF WINDOWS}
Uses WinDos,EMS_DRV;
{$ELSE}
Uses Dos,Crt,EMS_DRV;
{$ENDIF}

{
procedure Test;
procedure Alokuj_Pamat;
procedure Uvolni_Pamat;
procedure Vyplni_Pamat(Cislo:byte);
procedure Zapis_Do_Pamati(Page,Index:word; Num:byte);
procedure Blok_Do_Pamati(Page,Index,Koniec:word; Num:byte);
procedure Citaj_Blok_Z_Portu(Stranka: pointer; Port, Size:word);
function Citaj_Z_Pamati(Page,Index:word):byte;
procedure Zapis_Do_Pamati_Linearne(Adresa:longint; Num:byte);
function Citaj_Z_Pamati_Linearne(Adresa:longint):byte;
}

var  Premenna        : byte;
     Linearna_Adresa : longint;

begin
     HighVideo;
     ClrScr;
     WriteLn('Maximalna dostupna EMS : ',MaxEMSAvail div 1024,' kB');
     WriteLn('Velkost stranok EMS    : ',Segment,' Byte');
     WriteLn('Pocet stranok EMS      : ',MaxPages);
     Delay(2000);
     Test;                                       {Spusti alokaciu, vyplnenie, uvolnenie pamati EMS !!!}
     Alokuj_Pamat;                               {Alokuje pamat v EMS pod DPMI}
     Vyplni_Pamat($00);                          {Vyplni celu alokovanu pamat cislom}
     Zapis_Do_Pamati(0,0,$FF);                   {Zapise do Stranky[0] na adresu 0 cislo $0FF}
     Zapis_Do_Pamati(0,1,Port[$378]);            {Zapise do Stranky[0] na adresu 1 cislo precitane z portu 378h}
     Blok_Do_Pamati(0,0,5,1);                    {Kopiruje blok cisel 1 do pamati v stranke od adresy 0 do 5}
     Premenna:=(Citaj_Z_Pamati(0,5));            {Precita zo stranky[0] piaty byte}
     Citaj_Blok_Z_Portu(Stranka[2],$378,Segment);{Precita blok byte urceny adresou portou a velkostou segmentu}
     Stranka[1]^:=Stranka[0]^;                   {Obsah Stranky[0] prekopiruje do Stranky[1]}
     Beep;
     for Linearna_Adresa:=0 to Segment*MaxPages do
     begin
          Zapis_Do_Pamati_Linearne(Linearna_Adresa,$ED); {Vyplnim celu pamat od 0..16MB cislom 0EDh}
     end;
     Uvolni_Pamat;                               {Uvolni alokovanu pamat}
end.